"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var __cluedIn = global.__cluedIn || window.__cluedIn || {};

var getCluedInGlobal = exports.getCluedInGlobal = function getCluedInGlobal(name, domElementName, defaultValue) {
  if (document) {
    var domElement = document.getElementById(domElementName || name);
    if (domElement) {
      var domValue = domElement.value;
      if (domValue) {
        return domValue;
      }
    }
  }
  if (__cluedIn && __cluedIn[name]) {
    return __cluedIn[name];
  }

  if (process && process.env) {
    return process.env[name];
  }

  return defaultValue;
};

exports.default = {
  getCluedInGlobal: getCluedInGlobal
};