'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var removeDuplicate = function removeDuplicate(collection, keyname) {
  var output = [];
  var keys = [];

  collection.forEach(function (item) {
    var key = item[keyname];
    if (keys.indexOf(key) === -1) {
      keys.push(key);
      output.push(item);
    }
  });

  return output;
}; /* eslint-disable eqeqeq */

var _sortByName = function _sortByName(a, b) {
  if (a.name < b.name) {
    return -1;
  }
  if (a.name > b.name) {
    return 1;
  }
  return 0;
};

exports.default = {
  removeDuplicate: removeDuplicate,
  sortByName: function sortByName(array) {
    return array.sort(_sortByName);
  },
  compact: _lodash.compact,
  remove: _lodash.remove,
  first: _lodash.first,
  rest: _lodash.rest,
  uniq: _lodash.uniq,
  without: _lodash.without,
  take: _lodash.take,
  takeRight: _lodash.takeRight,
  fill: function fill(value, len) {
    if (len == 0) return [];
    var a = [value];
    while (a.length * 2 <= len) {
      a = a.concat(a);
    }if (a.length < len) a = a.concat(a.slice(0, len - a.length));
    return a;
  },
  move: function move(arr, old_index, new_index) {
    if (new_index >= arr.length) {
      var k = new_index - arr.length;
      while (k-- + 1) {
        arr.push(undefined);
      }
    }
    arr.splice(new_index, 0, arr.splice(old_index, 1)[0]);
    return arr; // for testing purposes
  }
};