'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _property = require('../property');

var _image = require('../image');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var toVM = function toVM(item, token, small) {
  var mainItem;

  mainItem = small ? item.entity : item.Entity ? item.Entity.entity : item.entity.entity;

  mainItem.data = mainItem.processedData;
  mainItem.name = mainItem.data.displayName || mainItem.data.name;

  mainItem.id = mainItem['attribute-id'];

  delete mainItem['attribute-id'];
  delete mainItem['attribute-organization'];
  delete mainItem['attribute-culture'];
  delete mainItem.processedData;

  var hasDescription = mainItem.data.description ? true : false;
  var differentNameAndDescription = !(mainItem.data.description === mainItem.name);

  mainItem.showDescription = differentNameAndDescription && hasDescription;

  mainItem.providers = mainItem.data['provider-origins'];

  if (mainItem.showDescription && mainItem.data.description.length > 200) {
    mainItem.descriptionFormatted = mainItem.data.description.substring(0, 200) + '...';
  }

  if (mainItem.data.previewImage) {
    if (mainItem.data.previewImage['attribute-uri']) {
      mainItem.hasLogo = true;
      mainItem.logoUrl = (0, _image.addTokenToImage)(mainItem.data.previewImage['attribute-uri'], token, true);
      mainItem.largeLogoUrl = (0, _image.addTokenToImage)(mainItem.data.previewImage['attribute-uri'], token, false, 'medium');
    }
  }

  if (mainItem.data.previewImage) {
    if (mainItem.data.previewImage['attribute-uri']) {
      mainItem.previewUrl = (0, _image.addTokenToImage)(mainItem.data.previewImage['attribute-uri'], token);
      mainItem.hasPreview = true;
    }
  }

  if (mainItem.name && mainItem.name.length > 100) {
    mainItem.name = mainItem.name.substring(0, 100) + '...';
  }

  mainItem.FollowersCount = mainItem.NumberOfFollowers = mainItem.NumberOfFollowers || 0;

  mainItem.path = void 0;
  mainItem.SuggestedSearches = item.SuggestedSearches;

  if (mainItem.data) {
    if (mainItem.data.properties) {
      mainItem.social = (0, _property.extractSocial)(mainItem.data.properties);
      mainItem.embedUrl = mainItem.data.properties['property-file.embedUrl'] || '';
      mainItem.editUrl = mainItem.data.properties['property-file.editUrl'] || '';
    }

    mainItem.data.uri = mainItem.data.uri ? mainItem.data.uri.replace(/\+/g, '%20') : '';
    mainItem.data.modifiedDateFormatted = mainItem.data.modifiedDate ? (0, _moment2.default)(mainItem.data.modifiedDate).fromNow() : void 0;
    mainItem.data.createdDateFormatted = mainItem.data.createdDate ? (0, _moment2.default)(mainItem.data.createdDate).fromNow() : void 0;
    mainItem.data.discoveryDate = mainItem.data.discoveryDate ? (0, _moment2.default)(mainItem.data.discoveryDate).fromNow() : void 0;
  }

  return mainItem;
};

exports.default = {
  toVM: toVM
};