'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.findFromKeyValue = findFromKeyValue;
exports.extractSocial = extractSocial;

var _validation = require('../validation');

var _validation2 = _interopRequireDefault(_validation);

var _social = require('./propertyConfiguration/social');

var _social2 = _interopRequireDefault(_social);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function findFromKeyValue(properties, key) {
  var p = properties.find(function (prop) {
    return prop && prop.key === key;
  });
  return p ? p.value : undefined;
}

function extractSocial(properties) {

  var result = [];

  if (!properties || properties.length === 0) {
    return [];
  }

  for (var social in _social2.default) {
    var propertyKey = _social2.default[social];

    if (_validation2.default.is.a.string(propertyKey)) {
      var value = properties[propertyKey];

      if (value) {
        result.push({ key: social, value: value });
      }
    } else if (_validation2.default.is.an.array(propertyKey)) {
      var valueFromArray = propertyKey.find(function (p) {
        return properties[p];
      });

      if (valueFromArray && properties[valueFromArray]) {
        result.push({ key: social, value: properties[valueFromArray] });
      }
    }
  }

  return result;
}