'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _empty = require('./ises/empty');

var _empty2 = _interopRequireDefault(_empty);

var _nullorundefined = require('./ises/nullorundefined');

var _nullorundefined2 = _interopRequireDefault(_nullorundefined);

var _type = require('./ises/type');

var _type2 = _interopRequireDefault(_type);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var is = {
  a: {},
  an: {},
  not: {
    a: {},
    an: {}
  }
};

var ises = {
  'arguments': ['arguments', (0, _type2.default)('arguments')],
  'array': ['array', (0, _type2.default)('array')],
  'boolean': ['boolean', (0, _type2.default)('boolean')],
  'date': ['date', (0, _type2.default)('date')],
  'function': ['function', 'func', 'fn', (0, _type2.default)('function')],
  'null': ['null', (0, _type2.default)('null')],
  'number': ['number', 'integer', 'int', (0, _type2.default)('number')],
  'object': ['object', (0, _type2.default)('object')],
  'regexp': ['regexp', (0, _type2.default)('regexp')],
  'string': ['string', (0, _type2.default)('string')],
  'undefined': ['undefined', (0, _type2.default)('undefined')],
  'empty': ['empty', _empty2.default],
  'nullorundefined': ['nullOrUndefined', 'nullorundefined', _nullorundefined2.default]
};

(0, _keys2.default)(ises).forEach(function (key) {

  var methods = ises[key].slice(0, ises[key].length - 1);
  var fn = ises[key][ises[key].length - 1];

  methods.forEach(function (methodKey) {
    is[methodKey] = is.a[methodKey] = is.an[methodKey] = fn;
    is.not[methodKey] = is.not.a[methodKey] = is.not.an[methodKey] = function () {
      return fn.apply(this, arguments) ? false : true;
    };
  });
});

exports.default = {
  isEmail: function isEmail(email) {
    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
  },
  isUrl: function isUrl(str) {
    var regexp = /(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/;
    return regexp.test(str);
  },
  is: is,
  isValidFileName: function isValidFileName(fileName) {
    var ext = fileName.split('.').pop();
    return ext.toLowerCase() === 'png' || ext.toLowerCase() === 'jpg' || ext.toLowerCase() === 'jpeg' || ext.toLowerCase() === 'gif';
  }
};