'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setContext = exports.logMessage = exports.logException = undefined;

var _simpleAssign = require('simple-assign');

var _simpleAssign2 = _interopRequireDefault(_simpleAssign);

var _fromServer = require('../fromServer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var logException = exports.logException = function logException(ex) {
  if (window.Raven && _fromServer.env === 'production') {
    window.Raven.captureException(ex);
    /*eslint no-console:0*/
    window.console && console.error && console.error(ex);
  }
};

var logMessage = exports.logMessage = function logMessage(message) {
  if (window.Raven && _fromServer.env === 'production') {
    window.Raven.captureMessage(message);
    /*eslint no-console:0*/
    window.console && console.error && console.error(message);
  }
};

var setContext = exports.setContext = function setContext() {
  var context = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  if (window.Raven && _fromServer.env === 'production') {
    var generalContext = {
      clientId: _fromServer.clientId,
      env: _fromServer.env,
      teamDomain: _fromServer.teamDomain
    };

    Raven.setUserContext((0, _simpleAssign2.default)({}, context, generalContext));
  }
};