'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createAnalytics = createAnalytics;

var _tracking = require('../tracking');

var _fromServer = require('../fromServer');

var _fromServer2 = _interopRequireDefault(_fromServer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var handleAction = function handleAction(store, next, action, options) {
  if (!action.meta || !action.meta.analytics && _fromServer2.default.env !== 'production' || action.type.indexOf('@@redux-form') > -1) {
    return next(action);
  }

  var _action$meta$analytic = action.meta.analytics,
      eventType = _action$meta$analytic.eventType,
      eventPayload = _action$meta$analytic.eventPayload;


  (0, _tracking.track)(eventType, eventPayload);

  return next(action);
};

function createAnalytics() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  return function (store) {
    return function (next) {
      return function (action) {
        return handleAction(store, next, action, options);
      };
    };
  };
};