'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

exports.default = function (options) {
  var prefix = options.prefix || 'WEBSOCKET_MESSAGE';
  if ((0, _typeof3.default)(options.handlers) !== 'object') throw new Error('Missing handlers field from options');

  return function (store) {
    return function (next) {
      return function (action) {
        var type = action.type,
            payload = action.payload;

        var _split = (type || '').split('/'),
            _split2 = (0, _slicedToArray3.default)(_split, 2),
            pre = _split2[0],
            event = _split2[1];

        next(action);
        if (pre && event && pre === prefix && event in options.handlers && Array.isArray(payload)) {
          var nextAction = options.handlers[event].apply(null, payload);
          store.dispatch(nextAction);
        }
      };
    };
  };
};

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }