'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.register = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _reduxThunk = require('redux-thunk');

var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

var _reduxLogger = require('redux-logger');

var _reduxLogger2 = _interopRequireDefault(_reduxLogger);

var _redux = require('redux');

var _fromServer = require('../fromServer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getRegistry = function getRegistry() {
  var registry = window.__cluedin_registry;
  if (!registry) {
    registry = {};
    registry.reducers = {}; //registry.reducers || {};
    registry.middlewares = []; //
    window.__cluedin_registry = registry;
  }

  return registry;
};

var register = exports.register = function register(storeName, reducer, middlewares) {
  var registry = getRegistry();

  if (registry.reducers[storeName]) {
    console.log('Trying to register the same store');
    return;
  }
  if (middlewares && middlewares.length) registry.middlewares.push.apply(registry.middlewares, middlewares);
  registry.reducers[storeName] = reducer;
};

var composeEnhancers = window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__ || _redux.compose;
function compileStore(initialState) {
  var registry = getRegistry();

  var allMiddleware = [_reduxThunk2.default];

  if (!_fromServer.isProduction) {
    allMiddleware.push((0, _reduxLogger2.default)());
  }

  allMiddleware = allMiddleware.concat([].concat((0, _toConsumableArray3.default)(registry.middlewares)));

  // HACK: bit of a hack to merge the widget reducer into the root
  var widgetReducer = (0, _extends3.default)({}, registry.reducers.widget);
  delete registry.reducers.widget;

  var rootReducer = (0, _redux.combineReducers)((0, _extends3.default)({}, widgetReducer, registry.reducers));

  return (0, _redux.createStore)(rootReducer, initialState, composeEnhancers(_redux.applyMiddleware.apply(undefined, (0, _toConsumableArray3.default)(allMiddleware))));
}

exports.default = {
  register: register,
  compileStore: compileStore
};