'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setPeople = exports.track = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.trackable = trackable;

var _fromServer = require('../fromServer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mixpanel = window.mixpanel;

var track = exports.track = function track(eventName, options) {
  if (mixpanel && _fromServer.env === 'production') {
    mixpanel.track(eventName, options);
  }
};

var setPeople = exports.setPeople = function setPeople(userId, options, extra) {
  if (mixpanel) {
    mixpanel.people.set(userId, options, extra);
  }
};

function trackable(action, event) {
  var properties = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var analytics = {
    eventType: event,
    eventPayload: properties
  };

  return (0, _extends3.default)({}, action, { meta: { analytics: analytics } });
}